Option Explicit On
Option Strict On

Imports System.IO


''' <summary>
''' C\[Xt@C̉̓NXłB
''' OpenCṼwb_t@CpłB]ł͂܂B
''' </summary>
''' <remarks></remarks>
Public Class CSourceParser

    '----------------------------------------------------------

#Region "g[NNX֌W"

    ''' <summary>g[N^Cv</summary> 
    Public Enum EnumTokenType
        Unknown = 0             's
        EndOfLine = 1           'sg[N
        ConstNumber = 10        'l萔
        ConstString = 11        '萔
        ConstChar = 12          '萔
        Symbol = 20             'L
    End Enum

    ''' <summary>
    ''' g[Nf[^i[NXłB
    ''' </summary>
    ''' <remarks></remarks>
    Public Class Token
        ''' <summary>g[N^Cvێ܂B</summary> 
        Public TokenType As EnumTokenType
        ''' <summary>g[N̕f[^ێ܂B</summary> 
        Public ValueString As String
        ''' <summary>Og[NƂ̊Ԃɋ󔒂ǂ̏ێ܂B</summary> 
        Public HasSpace As Boolean

        ''' <summary>񉻂܂B</summary> 
        Public Overrides Function ToString() As String
            Dim tp As String = TokenType.ToString.Substring(0, 1)
            If HasSpace Then tp = tp.ToUpper Else tp = tp.ToLower
            Return String.Format("[{0}:{1}]", ValueString, tp)
        End Function
    End Class

#End Region

#Region "Cxg`"

    ''' <summary>\[Xsǂݍ񂾎ɔ܂B</summary> 
    Public Event OnReadLine(ByVal Text As String)

    ''' <summary>̃g[Noɔ܂B</summary> 
    Public Event OnPickupToken(ByVal TokenValueText As String, ByVal TokenType As EnumTokenType)

    ''' <summary>vvZbTsoɔ܂B</summary> 
    Public Event OnPickupPreproccesor(ByVal TokenList As List(Of Token))

    ''' <summary>vg^Cv錾oɔ܂B</summary> 
    Public Event OnPickupPrototypeDefine(ByVal TokenList As List(Of Token))

    ''' <summary>^Cv`oɔ܂B</summary> 
    Public Event OnPickupTypeDefine(ByVal TokenList As List(Of Token))

    ''' <summary>֐oɔ܂B</summary> 
    Public Event OnPickupFunctionDefine(ByVal TokenList As List(Of Token))

    ''' <summary>sȍsoɔ܂B</summary> 
    Public Event OnPickupState(ByVal TokenList As List(Of Token))



#End Region


    '----------------------------------------------------------
    'f[^

#Region "vCx[gϐ"

    ''' <summary>͒̃RgԂێ܂B</summary> 
    Private mNowComment As Boolean

    ''' <summary>͒̃g[NXgێ܂B</summary> 
    Private mTokenList As New List(Of Token)
    ''' <summary>͒̃g[NXg^Cvێ܂B</summary> 
    Private mLineType As EnumLineType
    ''' <summary>͒̃GXP[vێ܂B</summary> 
    Private mEscapseFlag As Boolean
    ''' <summary>ubÑlXgxێ܂B</summary> 
    Private mBlockNestLevel As Integer
    ''' <summary>ubN̗Lێ܂B</summary> 
    Private mHasBlock As Boolean

#End Region

#Region "p萔"

    ''' <summary>s^Cv</summary> 
    Private Enum EnumLineType
        Unknown = 0
        Preprocessor = 1
        State = 2
        TypeDefine = 3
        PrototypeDefine = 4
        FunctionDefine = 5
    End Enum

#End Region


    '----------------------------------------------------------

    ''' <summary>
    ''' \[Xt@Cǂݍ݁A͏s܂B
    ''' t@C̏IɒB܂ŁAeCxg܂B
    ''' </summary>
    ''' <param name="FileStream">̓t@CXg[</param>
    ''' <remarks></remarks>
    Public Sub Start(ByVal FileStream As StreamReader)

        '
        mNowComment = False
        mLineType = EnumLineType.Unknown
        mEscapseFlag = False
        mBlockNestLevel = 0
        mHasBlock = False

        't@C̏I܂ōsPʂŏ
        Dim ll As String
        Do While Not FileStream.EndOfStream

            'sǍ
            ll = FileStream.ReadLine

            'f[^o
            RaiseEvent OnReadLine(ll)

            's
            ReadLine(ll)

        Loop

        't@CN[Y
        FileStream.Close()
        FileStream = Nothing

    End Sub

    ''' <summary>
    ''' s͂̕܂B
    ''' </summary>
    ''' <param name="SrcText"></param>
    ''' <remarks></remarks>
    Public Sub ReadLine(ByVal SrcText As String)

        'tO
        Dim qflg As Boolean = False     'NH[e[VtO
        Dim qchr As Char = Chr(0)       'NH[e[V
        Dim eflg As Boolean = False     'GXP[vtO
        Dim lastcc As Char = Chr(0)     'O̕
        Dim tkn As New System.Text.StringBuilder    'g[N
        Dim hs As Boolean = False       'g[Nԋ󔒃tO

        'ꕶÂ
        For Each cc As Char In SrcText

            'GXP[v
            If Not mNowComment Then
                If cc = "\"c Then
                    mEscapseFlag = Not mEscapseFlag
                    Continue For
                Else
                    mEscapseFlag = False
                End If
            End If

            If mNowComment Then
                'Rg
                'ǂݔ΂

                'ImF
                If (lastcc = "*"c) And (cc = "/"c) Then
                    'RgI[

                    'RgI
                    mNowComment = False
                End If
            ElseIf qflg Then
                'NH[e[V

                'g[Nɒǉ
                tkn.Append(cc)

                'ImF
                If qchr = cc Then
                    'NH[e[VI
                    qflg = False

                    'g[No
                    Select Case qchr
                        Case """"c
                            OutputToken(tkn, EnumTokenType.ConstString, hs)
                        Case "'"c
                            OutputToken(tkn, EnumTokenType.ConstChar, hs)
                    End Select
                End If
            Else
                Select Case cc
                    Case " "c, _
                         ControlChars.Cr, ControlChars.Lf, ControlChars.Tab '؂
                        'g[No
                        OutputToken(tkn, EnumTokenType.Unknown, hs)

                        '󔒂
                        hs = True

                    Case """"c, "'"c    'NH[e[V
                        'g[No
                        OutputToken(tkn, EnumTokenType.Unknown, hs)

                        'NH[e[VJn
                        qchr = cc
                        qflg = True
                        tkn.Append(cc)

                    Case "!"c, "#"c, "%"c, "("c, ")"c, _
                         "+"c, ","c, "-"c, "."c, _
                         ":"c, ";"c, "<"c, "="c, ">"c, "?"c, _
                         "["c, "]"c, "^"c, "{"c, "}"c, _
                         "~"c           'L

                        'g[No
                        OutputToken(tkn, EnumTokenType.Unknown, hs)

                        'g[No
                        tkn.Append(cc)
                        OutputToken(tkn, EnumTokenType.Symbol, hs)

                    Case "*"c
                        If lastcc = "/"c Then
                            'RgJn
                            mNowComment = True
                            tkn.Length = 0
                        Else
                            'g[No
                            OutputToken(tkn, EnumTokenType.Unknown, hs)

                            'g[No
                            tkn.Append(cc)
                            OutputToken(tkn, EnumTokenType.Symbol, hs)

                        End If

                    Case "/"c
                        If lastcc = "/"c Then
                            'sRg
                            tkn.Length = 0
                            Exit For
                        End If

                        'g[No
                        OutputToken(tkn, EnumTokenType.Unknown, hs)

                        '̃g[Nɐݒ
                        tkn.Append(cc)

                    Case "&"c, "|"c     'L(񕶎L)
                        If lastcc = cc Then
                            '&&||Ƃăg[No
                            tkn.Append(cc)
                            OutputToken(tkn, EnumTokenType.Symbol, hs)
                        Else
                            'g[No
                            OutputToken(tkn, EnumTokenType.Unknown, hs)

                            '̃g[Nɐݒ
                            tkn.Append(cc)
                        End If

                    Case Else           '̑̕

                        Select Case lastcc
                            Case "&"c, "|"c, "/"c, "*"c
                                'g[No
                                OutputToken(tkn, EnumTokenType.Symbol, hs)
                        End Select

                        'g[Nɒǉ
                        tkn.Append(cc)

                End Select

            End If

            lastcc = cc
        Next

        If qflg Then
            'NH[e[VĂȂ
            Throw New Exception("NH[e[VĂ܂B")
        End If

        'g[No
        OutputToken(tkn, EnumTokenType.Unknown, hs)

        'sg[No
        OutputToken(Nothing, EnumTokenType.EndOfLine, False)

    End Sub

    ''' <summary>
    ''' og[N܂B
    ''' </summary>
    ''' <param name="TokenValueText">g[N</param>
    ''' <remarks>g[N͋󕶎ɂ܂B</remarks>
    Private Sub OutputToken(ByVal TokenValueText As System.Text.StringBuilder, ByVal TokenType As EnumTokenType, ByRef HasSpace As Boolean)

        '`FbN
        If TokenType = EnumTokenType.Unknown Then
            If TokenValueText Is Nothing Then Exit Sub
            If TokenValueText.Length = 0 Then Exit Sub
        End If

        'g[N쐬
        Dim tkn As New Token
        tkn.TokenType = TokenType
        If TokenValueText IsNot Nothing Then
            tkn.ValueString = TokenValueText.ToString
            TokenValueText.Length = 0
        End If
        tkn.HasSpace = HasSpace
        HasSpace = False

        Select Case mLineType
            Case EnumLineType.Unknown
                If tkn.TokenType = EnumTokenType.EndOfLine Then
                    's
                    Exit Sub
                ElseIf (tkn.TokenType = EnumTokenType.Symbol) And (tkn.ValueString = "#") Then
                    'vvZbTJn
                    mLineType = EnumLineType.Preprocessor
                    mTokenList.Clear()
                    mTokenList.Add(tkn)
                ElseIf tkn.ValueString = "CVAPI" Then
                    'vg^Cv錾Jn
                    mLineType = EnumLineType.PrototypeDefine
                    mTokenList.Clear()
                    mTokenList.Add(tkn)
                ElseIf tkn.ValueString = "typedef" Then
                    '^Cv`Jn
                    mLineType = EnumLineType.TypeDefine
                    mTokenList.Clear()
                    mTokenList.Add(tkn)
                ElseIf tkn.ValueString = "CV_INLINE" Then
                    '֐`Jn
                    mLineType = EnumLineType.FunctionDefine
                    mTokenList.Clear()
                    mTokenList.Add(tkn)
                Else
                    'ʏs
                    mLineType = EnumLineType.State
                    mTokenList.Clear()
                    mTokenList.Add(tkn)
                    mHasBlock = False
                End If

            Case EnumLineType.Preprocessor  'vvZbT
                If (tkn.TokenType = EnumTokenType.EndOfLine) And (mEscapseFlag = False) Then
                    's擾
                    RaiseEvent OnPickupPreproccesor(mTokenList)
                    mTokenList.Clear()
                    mLineType = EnumLineType.Unknown
                ElseIf tkn.TokenType = EnumTokenType.EndOfLine Then
                    'GXP[vꂽs͖
                Else
                    'Xgɒǉ
                    mTokenList.Add(tkn)
                End If

            Case EnumLineType.TypeDefine
                '^Cv`

                If (tkn.TokenType = EnumTokenType.Symbol) And _
                   (tkn.ValueString = ";") And _
                   (mBlockNestLevel = 0) Then
                    '擾
                    RaiseEvent OnPickupTypeDefine(mTokenList)
                    mTokenList.Clear()
                    mLineType = EnumLineType.Unknown
                    Exit Select
                End If
                If tkn.TokenType = EnumTokenType.EndOfLine Then
                    's͖
                    Exit Select
                End If

                'ubNx
                If tkn.TokenType = EnumTokenType.Symbol Then
                    If tkn.ValueString = "{" Then
                        mBlockNestLevel += 1
                    ElseIf tkn.ValueString = "}" Then
                        mBlockNestLevel -= 1
                    End If
                End If

                'Xgɒǉ
                mTokenList.Add(tkn)

            Case EnumLineType.PrototypeDefine
                'vg^Cv錾

                If (tkn.TokenType = EnumTokenType.Symbol) And _
                   (tkn.ValueString = ";") Then
                    '擾
                    RaiseEvent OnPickupPrototypeDefine(mTokenList)
                    mTokenList.Clear()
                    mLineType = EnumLineType.Unknown
                    Exit Select
                End If
                If tkn.TokenType = EnumTokenType.EndOfLine Then
                    's͖
                    Exit Select
                End If

                'Xgɒǉ
                mTokenList.Add(tkn)

            Case EnumLineType.FunctionDefine
                '֐`

                If (tkn.TokenType = EnumTokenType.Symbol) And _
                   (tkn.ValueString = ";") And _
                   (mBlockNestLevel = 0) Then
                    '擾
                    RaiseEvent OnPickupFunctionDefine(mTokenList)
                    mTokenList.Clear()
                    mLineType = EnumLineType.Unknown
                    Exit Select
                End If
                If tkn.TokenType = EnumTokenType.EndOfLine Then
                    's͖
                    Exit Select
                End If

                'ubNx
                If tkn.TokenType = EnumTokenType.Symbol Then
                    If tkn.ValueString = "{" Then
                        mBlockNestLevel += 1
                    ElseIf tkn.ValueString = "}" Then
                        mBlockNestLevel -= 1
                        If mBlockNestLevel = 0 Then
                            '擾
                            RaiseEvent OnPickupFunctionDefine(mTokenList)
                            mTokenList.Clear()
                            mLineType = EnumLineType.Unknown
                            Exit Select
                        End If
                    End If
                End If

                'Xgɒǉ
                mTokenList.Add(tkn)

            Case EnumLineType.State

                If (tkn.TokenType = EnumTokenType.Symbol) And _
                   (tkn.ValueString = ";") And _
                   (mBlockNestLevel = 0) Then
                    's擾
                    RaiseEvent OnPickupState(mTokenList)
                    mTokenList.Clear()
                    mLineType = EnumLineType.Unknown
                    Exit Select
                End If
                If tkn.TokenType = EnumTokenType.EndOfLine Then
                    's͖
                    Exit Select
                End If

                'ubNx
                If tkn.TokenType = EnumTokenType.Symbol Then
                    If tkn.ValueString = "{" Then
                        mBlockNestLevel += 1
                    ElseIf tkn.ValueString = "}" Then
                        mBlockNestLevel -= 1
                    End If
                End If

                'Xgɒǉ
                mTokenList.Add(tkn)

        End Select

    End Sub

End Class
